-------------------------------------------------------------------------

--

-- File name   : bar_decode.vhd

--             :  

-- Title       : 

--             :  

-- Functional  : 

-- Description : block to decode bar reads and writes for each pci bar

--             : 

-- Created On  : 8/7/00   

--             :

-- Testbed     :

-- Requirements: <testing requirements -- explain relation to spec.>

--             :

-- Coding      :  

-- Standard    : Active low signals are identified with '_n' or '_N'.

--             : Only one entity-architecture pair per file.

--             :

-- Synthesis   :

-- Standard    : All outputs registered when possible.

--             :

-- Synthesis   :

-- Warnings    : <NO warnings without written explanation>

--             :

-- Device      :

-- Utilization : <est. clb count, tbufs, dffs, etc.>

--             :

-- Limitations : For use in Xilinx FPGA

--             : 

-- Developers  : Tom Curran

--             : Memec Design

--             : 30 Nagog Park

--             : Acton, MA  01720

--             : Ph 978.266.9193

--             : Fx 978.266.9194

-- ----------------------------------------------------------------------

-- Revision History :

-- ----------------------------------------------------------------------

--   Version   | Author          | Changes Made:      | Mod. Date:

--      1.0    | tom curran      | First write        | 8/7/00      

-- ----------------------------------------------------------------------



library ieee;

use ieee.std_logic_1164.all;

use ieee.std_logic_unsigned.all;



entity bar_decode is

port(                       

   s_data : in std_logic;

   clk : in std_logic;

   s_wrdn : in std_logic;

   reset : in std_logic;

   decoded_hit : in std_logic;

   bar_rd : out std_logic;

   bar_wr : out std_logic;

   bar_hit : out std_logic

   );

end bar_decode;



--}} End of automatically maintained section



architecture rtl of bar_decode is

begin



	 -- enter your statements here --

   decoded_hits: process (clk,reset)

   begin

   	if reset='1' then	--asynchronous reset active high

  		   bar_rd <= '0';

  		   bar_wr <= '0';

         bar_hit <= '0';

   	elsif (clk'event and clk='1') then  --clk rising edge

         if (decoded_hit = '1') then

   		   bar_rd <= not s_wrdn;

   		   bar_wr <= s_wrdn;

            bar_hit <= '1';

         elsif (s_data = '0') then

   		   bar_rd <= '0';

   		   bar_wr <= '0';

            bar_hit <= '0';

      	end if;

    	end if;

   end process;



end rtl;

