-------------------------------------------------------------------------

--

-- File name   : userapp.vhd

--             :  

-- Title       : 

--             :  

-- Functional  : 

-- Description : 

--             : 

-- Created On  : 

--             :

-- Testbed     :

-- Requirements: <testing requirements -- explain relation to spec.>

--             :

-- Coding      :  

-- Standard    : Active low signals are identified with '_n' or '_N'.

--             : Only one entity-architecture pair per file.

--             :

-- Synthesis   :

-- Standard    : All outputs registered when possible.

--             :

-- Synthesis   :

-- Warnings    : <NO warnings without written explanation>

--             :

-- Device      :

-- Utilization : <est. clb count, tbufs, dffs, etc.>

--             :

-- Limitations : For use in Xilinx FPGA

--             : 

-- Developers  : Tom Curran

--             : Memec Design

--             : 30 Nagog Park

--             : Acton, MA  01720

--             : Ph 978.266.9193

--             : Fx 978.266.9194

-- ----------------------------------------------------------------------

-- Revision History :

-- ----------------------------------------------------------------------

--   Version   | Author          | Changes Made:      | Mod. Date:

--      1.0    | tom curran      | First write        | 8/7/00      

-- ----------------------------------------------------------------------



library ieee;

use ieee.std_logic_1164.all;

use ieee.std_logic_unsigned.all;



--synopsys translate_off

--library unisim;

--use unisim.all;

--synopsys translate_on



entity userapp is

port(

   clk : in std_logic;

   reset : in std_logic;

   s_data : in std_logic;

   s_data_vld : in std_logic;

   s_wrdn : in std_logic;

   base_hit : in std_logic_vector(7 downto 0);

   c_ready : out std_logic;

   c_term : out std_logic;

   cfg_self : out std_logic;

   complete : out std_logic;

   intr_n : out std_logic;

   keepout : out std_logic;

   m_ready : out std_logic;

   m_wrdn : out std_logic;

   request : out std_logic;

   request64 : out std_logic;

   requesthold : out std_logic;

   s_abort : out std_logic;

   s_ready : out std_logic;

   s_term : out std_logic;

   slot64 : out std_logic;

   m_cbe : out std_logic_vector(7 downto 0);

   adio : inout std_logic_vector(31 downto 0);

   sub_data : out std_logic_vector(31 downto 0);



   --unused inputs

   --addr_vld : in std_logic;

   --cfg_hit : in std_logic;

   --cfg_vld : in std_logic;

   --s_src_en : in std_logic;

   --s_cbe : in std_logic_vector(3 downto 0);

   --addr : in std_logic_vector(31 downto 0);

   --pci_cmd : in std_logic_vector(15 downto 0);

   --m_data_vld : in std_logic;

   --m_src_en : in std_logic;

   --time_out : in std_logic;

   --devselq_n : in std_logic;

   --frameq_n : in std_logic;

   --irdyq_n : in std_logic;

   --stopq_n : in std_logic;

   --trdyq_n : in std_logic;

   --b_busy : in std_logic;

   --backoff : in std_logic;

   --idle : in std_logic;

   --dr_bus : in std_logic;

   --i_idle : in std_logic;

   --m_addr_n : in std_logic;

   --m_data : in std_logic;

   --csr : in std_logic_vector(39 downto 0);

   --perrq_n : in std_logic;

   --serrq_n : in std_logic;



   --userapp i/o's

   led_test : out std_logic;

   tensdigit : out std_logic_vector(6 downto 0) ;

   onesdigit : out std_logic_vector(6 downto 0) 

   );

end userapp;



architecture rtl of userapp is



  attribute syn_edif_bit_format : string;
  attribute syn_edif_scalar_format : string;
  attribute syn_noclockbuf : boolean;
  attribute syn_hier : string;
  attribute syn_edif_bit_format of rtl : architecture is "%u<%i>";
  attribute syn_edif_scalar_format of rtl : architecture is "%u";
  attribute syn_noclockbuf of rtl : architecture is true;
  attribute syn_hier of rtl : architecture is "hard";


   ---- component declarations -----

   component target_control

   port (

      bar_0_ready : in std_logic;

      bar_0_term : in std_logic;

      bar_0_sabort : in std_logic;

      bar_0_keepout : in std_logic;

      bar_0_intr_n : in std_logic;

      bar_0_hit : in std_logic;

      s_ready : out std_logic;

      s_term : out std_logic;

      s_abort : out std_logic;

      keepout : out std_logic;

      intr_n : out std_logic

      );

   end component ;



   component bar0

   port (

      base_hit : in std_logic;

      clk : in std_logic;

      reset : in std_logic;

      s_data : in std_logic;

      s_data_vld : in std_logic;

      s_wrdn : in std_logic;

      bar_hit : out std_logic;

      bar_intr_n : out std_logic;

      bar_keepout : out std_logic;

      bar_ready : out std_logic;

      bar_sabort : out std_logic;

      bar_term : out std_logic;

      adio : inout std_logic_vector(31 downto 0);

      led_test : out std_logic ;

      tensdigit : out std_logic_vector(6 downto 0) ;

      onesdigit : out std_logic_vector(6 downto 0) 

      );

   end component ;



   component benign

   port (

      clk : in std_logic;

      reset : in std_logic;

      cfg_self : out std_logic;

      complete : out std_logic;

      m_cbe : out std_logic_vector(7 downto 0);

      m_ready : out std_logic;

      m_wrdn : out std_logic;

      request : out std_logic;

      request64 : out std_logic;

      requesthold : out std_logic;

      slot64 : out std_logic

      );

   end component ;



   ---- signal declarations ----

   signal one : std_logic;

   signal zero : std_logic;

   signal heartbeat : std_logic ;

   signal bar_0_hit : std_logic ;

   signal bar_0_intr_n : std_logic ;

   signal bar_0_keepout : std_logic ;

   signal bar_0_ready : std_logic ;

   signal bar_0_sabort : std_logic ;

   signal bar_0_term : std_logic ;

   signal bar_1_hit : std_logic ;

   signal bar_1_intr_n : std_logic ;

   signal bar_1_keepout : std_logic ;

   signal bar_1_ready : std_logic ;

   signal bar_1_sabort : std_logic ;

   signal bar_1_term : std_logic ;

   signal foo_count : std_logic_vector(23 downto 0);

   

begin

   sub_data <= X"FFFFFFFF" ;

   

   static_config: process (clk,reset)

   begin

      if reset='1' then --asynchronous reset active high

         c_ready <= '0';

         c_term <= '0';

      elsif (clk'event and clk='1') then  --clk rising edge

         c_ready <= '1';

         c_term <= '1';

      end if;

   end process;



----  component instantiations  ----



   foo_bar0 : bar0

   port map(

      clk => clk,

      reset => reset,

      s_data => s_data,

      s_data_vld => s_data_vld,

      s_wrdn => s_wrdn,

      base_hit => base_hit(0),

      bar_hit => bar_0_hit,

      bar_intr_n => bar_0_intr_n,

      bar_keepout => bar_0_keepout,

      bar_ready => bar_0_ready,

      bar_sabort => bar_0_sabort,

      bar_term => bar_0_term,

      adio => adio,

      led_test => led_test,

      tensdigit => tensdigit,

      onesdigit => onesdigit

      );



   control : target_control

   port map(

      bar_0_ready => bar_0_ready,

      bar_0_term => bar_0_term,

      bar_0_sabort => bar_0_sabort,

      bar_0_keepout => bar_0_keepout,

      bar_0_intr_n => bar_0_intr_n,

      bar_0_hit => bar_0_hit,

      s_ready => s_ready,

      s_term => s_term,

      s_abort => s_abort,

      keepout => keepout,

      intr_n => intr_n

      );



   benign_initiator : benign

   port map(

      cfg_self => cfg_self,

      clk => clk,

      complete => complete,

      m_cbe => m_cbe,

      m_ready => m_ready,

      m_wrdn => m_wrdn,

      request => request,

      request64 => request64,

      requesthold => requesthold,

      reset => reset,

      slot64 => slot64

      );



end rtl;

